import * as go from "../../../release/go"
import Floorplan = require("./Floorplan");

class FloorplanPalette extends go.Palette {	

	private 

	constructor(div, floorplan: Floorplan, nodeDataArray) {
		super(div);

		let $ = go.GraphObject.make;
	    this.model = $(go.GraphLinksModel, { nodeDataArray: nodeDataArray });
	    this.contentAlignment = go.Spot.Center;
	    this.nodeTemplateMap = floorplan.nodeTemplateMap;
	    this.toolManager.contextMenuTool.isEnabled = false;

	    // add this new FloorplanPalette to the "palettes" field of its associated Floorplan
	    floorplan.palettes.push(this);

	} // end FloorplanPalette constructor

}

export = FloorplanPalette;
